#version 150

uniform sampler2D DiffuseSampler;

in vec2 texCoord;
in vec2 oneTexel;

uniform vec2 InSize;

uniform vec3 Gray;
uniform vec3 Offset;
uniform vec3 ColorScale;
uniform float Saturation;

out vec4 fragColor;

void main() {
   if (texCoord.x < 0.5 && texCoord.y > 0.5){
        fragColor = vec4(texture(DiffuseSampler, vec2(texCoord.x*2, texCoord.y*2-1)).r, 0, 0, 1.0);
    }
    else if (texCoord.x > 0.5 && texCoord.y > 0.5){
        fragColor = vec4(0, texture(DiffuseSampler, vec2(texCoord.x*2-1, texCoord.y*2-1)).g, 0, 1.0);
    }
    else if (texCoord.x > 0.25 && texCoord.x < 0.75 && texCoord.y < 0.5){
        fragColor = vec4(0, 0, texture(DiffuseSampler, vec2(texCoord.x*2-0.5, texCoord.y*2)).b, 1.0);
    }
    else{
        fragColor = vec4(0, 0, 0, 1.0);
    }
}
