#version 150

uniform sampler2D DiffuseSampler;

in vec2 texCoord;
in vec2 oneTexel;

uniform vec2 InSize;

uniform vec3 Gray;
uniform vec3 Offset;
uniform vec3 ColorScale;
uniform float Saturation;

out vec4 fragColor;

float ab(float a){
    if (a > 0){
        return a;
    }
    else{
        return -a;
    }
}

void main() {    
    if (texCoord.x < 0.3 && texCoord.y > 0.5){
        vec4 c = texture(DiffuseSampler, vec2(texCoord.x*3, texCoord.y*2-1));
        if (c.r == c.b && c.b == c.g){
            fragColor = vec4(c.r, 0, 0, 0);
        }
        else{
            fragColor = vec4(c.r - c.g - c.b, 0, 0, 1.0);
        }
    }
    else if (texCoord.x > 0.34 && texCoord.x < 0.67 && texCoord.y > 0.5){
        vec4 c = texture(DiffuseSampler, vec2(texCoord.x*3-1, texCoord.y*2-1));
        if (c.r == c.b && c.b == c.g){
            fragColor = vec4(0, c.r, 0, 0);
        }
        else{
            fragColor = vec4(0, c.g - c.r - c.b, 0, 1.0);
        }
    }
    else if (texCoord.x > 0.67 && texCoord.y > 0.5){
        vec4 c = texture(DiffuseSampler, vec2(texCoord.x*3-2, texCoord.y*2-1));
        if (c.r == c.b && c.b == c.g){
            fragColor = vec4(0, 0, c.r, 0);
        }
        else{
            fragColor = vec4(0, 0, c.b - c.r - c.g, 1.0);
        }
    }
    else if (texCoord.x < 0.34 && texCoord.y < 0.5){
        vec4 c = texture(DiffuseSampler, vec2(texCoord.x*2, texCoord.y*2));
        float d = ab(c.r - c.g) + c.b;
        if (c.r == c.b && c.b == c.g){
            fragColor = vec4(c.r, c.r, 0, 0);
        }
        else{
            fragColor = vec4(c.r - d, c.g - d, 0, 1.0);
        }
    }
    else if (texCoord.x > 0.34 && texCoord.x < 0.67 && texCoord.y < 0.5){
        vec4 c = texture(DiffuseSampler, vec2(texCoord.x*3-1, texCoord.y*2));
        float d = ab(c.g - c.b) + c.r;
        if (c.r == c.b && c.b == c.g){
            fragColor = vec4(0, c.r, c.r, 0);
        }
        else{
            fragColor = vec4(0, c.g - d, c.b - d, 1.0);
        }
    }
    else if (texCoord.x > 0.67 && texCoord.y < 0.5){
        vec4 c = texture(DiffuseSampler, vec2(texCoord.x*3-2, texCoord.y*2));
        float d = ab(c.b - c.r) + c.g;
        if (c.r == c.b && c.b == c.g){
            fragColor = vec4(c.r, 0, c.r, 0);
        }
        else{
            fragColor = vec4(c.r - d, 0, c.b - d, 1.0);
        }
    }
    else{
        fragColor = vec4(0, 0, 0, 1.0);
    }
}
